image: docker:latest
services:
  - "docker:dind"
stages:
  - test
  - git
  - build-and-push
  - deploy-k8s

variables:
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

test:
  stage: test
  image: python
  before_script:
    - pip install -r requirements.txt
  script:
    - echo "running test..."
    - python3 tests.py
  rules:
    - if: '$CI_COMMIT_BRANCH == "feature"'

push-to-main:
  stage: git
  before_script:
    - apk add git
    - git config --global user.email "${GIT_USER_EMAIL:-$CI_EMAIL}"
    - git config --global user.name "${GIT_USER_NAME:-$CI_USERNAME}"
  script:
    - git push -f "https://${CI_USERNAME}:${CI_TOKEN}@gitlab.com/mieli.ohad/weatherapp.git" HEAD:main
  when: on_success
  only:
    - feature

docker:
  stage: build-and-push
  before_script: 
    - echo $DOCKER_PASSWORD | docker login -u $DOCKER_USERNAME --password-stdin
  script:
    - docker build -t omeili/weapp:gitlabci-${CI_PIPELINE_ID} .
    - docker push omeili/weapp:gitlabci-${CI_PIPELINE_ID}
  when: on_success
  only:
    - feature

k8s:
  stage: deploy-k8s
  image: ubuntu:latest
  before_script:
    - apt-get update
    - apt-get install -y awscli
  script:
    - echo "install k8s"